123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266 |
- #!/bin/sh
- if [ "$1" = "" ]; then
- key=../apps/server.pem
- else
- key="$1"
- fi
- if [ "$2" = "" ]; then
- cert=../apps/server.pem
- else
- cert="$2"
- fi
- ssltest="../util/shlib_wrap.sh ./ssltest -s_key $key -s_cert $cert -c_key $key -c_cert $cert"
- if ../util/shlib_wrap.sh ../apps/openssl x509 -in $cert -text -noout | fgrep 'DSA Public Key' >/dev/null; then
- dsa_cert=YES
- else
- dsa_cert=NO
- fi
- if [ "$3" = "" ]; then
- CA="-CApath ../certs"
- else
- CA="-CAfile $3"
- fi
- if [ "$4" = "" ]; then
- extra=""
- else
- extra="$4"
- fi
- serverinfo="./serverinfo.pem"
- #############################################################################
- echo test sslv3
- $ssltest -ssl3 $extra || exit 1
- echo test sslv3 with server authentication
- $ssltest -ssl3 -server_auth $CA $extra || exit 1
- echo test sslv3 with client authentication
- $ssltest -ssl3 -client_auth $CA $extra || exit 1
- echo test sslv3 with both client and server authentication
- $ssltest -ssl3 -server_auth -client_auth $CA $extra || exit 1
- echo test sslv2/sslv3
- $ssltest $extra || exit 1
- echo test sslv2/sslv3 with server authentication
- $ssltest -server_auth $CA $extra || exit 1
- echo test sslv2/sslv3 with client authentication
- $ssltest -client_auth $CA $extra || exit 1
- echo test sslv2/sslv3 with both client and server authentication
- $ssltest -server_auth -client_auth $CA $extra || exit 1
- echo test sslv3 via BIO pair
- $ssltest -bio_pair -ssl3 $extra || exit 1
- echo test sslv3 with server authentication via BIO pair
- $ssltest -bio_pair -ssl3 -server_auth $CA $extra || exit 1
- echo test sslv3 with client authentication via BIO pair
- $ssltest -bio_pair -ssl3 -client_auth $CA $extra || exit 1
- echo test sslv3 with both client and server authentication via BIO pair
- $ssltest -bio_pair -ssl3 -server_auth -client_auth $CA $extra || exit 1
- echo test sslv2/sslv3 via BIO pair
- $ssltest $extra || exit 1
- echo test dtlsv1
- $ssltest -dtls1 $extra || exit 1
- echo test dtlsv1 with server authentication
- $ssltest -dtls1 -server_auth $CA $extra || exit 1
- echo test dtlsv1 with client authentication
- $ssltest -dtls1 -client_auth $CA $extra || exit 1
- echo test dtlsv1 with both client and server authentication
- $ssltest -dtls1 -server_auth -client_auth $CA $extra || exit 1
- echo test dtlsv1.2
- $ssltest -dtls12 $extra || exit 1
- echo test dtlsv1.2 with server authentication
- $ssltest -dtls12 -server_auth $CA $extra || exit 1
- echo test dtlsv1.2 with client authentication
- $ssltest -dtls12 -client_auth $CA $extra || exit 1
- echo test dtlsv1.2 with both client and server authentication
- $ssltest -dtls12 -server_auth -client_auth $CA $extra || exit 1
- if [ $dsa_cert = NO ]; then
- echo 'test sslv2/sslv3 w/o (EC)DHE via BIO pair'
- $ssltest -bio_pair -no_dhe -no_ecdhe $extra || exit 1
- fi
- echo test sslv2/sslv3 with 1024bit DHE via BIO pair
- $ssltest -bio_pair -dhe1024dsa -v $extra || exit 1
- echo test sslv2/sslv3 with server authentication
- $ssltest -bio_pair -server_auth $CA $extra || exit 1
- echo test sslv2/sslv3 with client authentication via BIO pair
- $ssltest -bio_pair -client_auth $CA $extra || exit 1
- echo test sslv2/sslv3 with both client and server authentication via BIO pair
- $ssltest -bio_pair -server_auth -client_auth $CA $extra || exit 1
- echo test sslv2/sslv3 with both client and server authentication via BIO pair and app verify
- $ssltest -bio_pair -server_auth -client_auth -app_verify $CA $extra || exit 1
- test_cipher() {
- _cipher=$1
- echo "Testing $_cipher"
- prot=""
- if [ $2 = "SSLv3" ] ; then
- prot="-ssl3"
- fi
- _exarg=$3
- $ssltest $_exarg -cipher $_cipher $prot
- if [ $? -ne 0 ] ; then
- echo "Failed $_cipher"
- exit 1
- fi
- }
- echo "Testing ciphersuites"
- exkeys=""
- ciphers="-EXP:-PSK:-SRP:-kDH:-kECDHe"
- if ../util/shlib_wrap.sh ../apps/openssl no-dhparam >/dev/null; then
- echo "skipping DHE tests"
- ciphers="$ciphers:-kDHE"
- fi
- if ../util/shlib_wrap.sh ../apps/openssl no-dsa >/dev/null; then
- echo "skipping DSA tests"
- ciphers="$ciphers:-aDSA"
- else
- exkeys="$exkeys -s_cert certD.ss -s_key keyD.ss"
- fi
- if ../util/shlib_wrap.sh ../apps/openssl no-ec >/dev/null; then
- echo "skipping EC tests"
- ciphers="$ciphers:!aECDSA:!kECDH"
- else
- exkeys="$exkeys -s_cert certE.ss -s_key keyE.ss"
- fi
- for protocol in TLSv1.2 SSLv3; do
- echo "Testing ciphersuites for $protocol"
- for cipher in `../util/shlib_wrap.sh ../apps/openssl ciphers "$protocol:$ciphers" | tr ':' ' '`; do
- test_cipher $cipher $protocol "$exkeys"
- done
- echo "testing connection with weak DH, expecting failure"
- if [ $protocol = "SSLv3" ] ; then
- $ssltest -s_cipher "EDH" -c_cipher "EDH:@SECLEVEL=1" -dhe512 -ssl3
- else
- $ssltest -s_cipher "EDH" -c_cipher "EDH:@SECLEVEL=1" -dhe512
- fi
- if [ $? -eq 0 ]; then
- echo "FAIL: connection with weak DH succeeded"
- exit 1
- fi
- done
- #############################################################################
- if ../util/shlib_wrap.sh ../apps/openssl no-dhparam; then
- echo skipping anonymous DH tests
- else
- echo test tls1 with 1024bit anonymous DH, multiple handshakes
- $ssltest -v -bio_pair -tls1 -cipher ADH -dhe1024dsa -num 10 -f -time $extra || exit 1
- fi
- if ../util/shlib_wrap.sh ../apps/openssl no-rsa; then
- echo skipping RSA tests
- else
- echo 'test tls1 with 1024bit RSA, no (EC)DHE, multiple handshakes'
- ../util/shlib_wrap.sh ./ssltest -v -bio_pair -tls1 -s_cert ../apps/server2.pem -no_dhe -no_ecdhe -num 10 -f -time $extra || exit 1
- if ../util/shlib_wrap.sh ../apps/openssl no-dhparam; then
- echo skipping RSA+DHE tests
- else
- echo test tls1 with 1024bit RSA, 1024bit DHE, multiple handshakes
- ../util/shlib_wrap.sh ./ssltest -v -bio_pair -tls1 -s_cert ../apps/server2.pem -dhe1024dsa -num 10 -f -time $extra || exit 1
- fi
- fi
- echo test tls1 with PSK
- $ssltest -tls1 -cipher PSK -psk abc123 $extra || exit 1
- echo test tls1 with PSK via BIO pair
- $ssltest -bio_pair -tls1 -cipher PSK -psk abc123 $extra || exit 1
- #############################################################################
- # Next Protocol Negotiation Tests
- $ssltest -bio_pair -tls1 -npn_client || exit 1
- $ssltest -bio_pair -tls1 -npn_server || exit 1
- $ssltest -bio_pair -tls1 -npn_server_reject || exit 1
- $ssltest -bio_pair -tls1 -npn_client -npn_server_reject || exit 1
- $ssltest -bio_pair -tls1 -npn_client -npn_server || exit 1
- $ssltest -bio_pair -tls1 -npn_client -npn_server -num 2 || exit 1
- $ssltest -bio_pair -tls1 -npn_client -npn_server -num 2 -reuse || exit 1
- #############################################################################
- # Custom Extension tests
- echo test tls1 with custom extensions
- $ssltest -bio_pair -tls1 -custom_ext || exit 1
- #############################################################################
- # Serverinfo tests
- echo test tls1 with serverinfo
- $ssltest -bio_pair -tls1 -serverinfo_file $serverinfo || exit 1
- $ssltest -bio_pair -tls1 -serverinfo_file $serverinfo -serverinfo_sct || exit 1
- $ssltest -bio_pair -tls1 -serverinfo_file $serverinfo -serverinfo_tack || exit 1
- $ssltest -bio_pair -tls1 -serverinfo_file $serverinfo -serverinfo_sct -serverinfo_tack || exit 1
- $ssltest -bio_pair -tls1 -custom_ext -serverinfo_file $serverinfo -serverinfo_sct -serverinfo_tack || exit 1
- #############################################################################
- # ALPN tests
- $ssltest -bio_pair -tls1 -alpn_client foo -alpn_server bar || exit 1
- $ssltest -bio_pair -tls1 -alpn_client foo -alpn_server foo -alpn_expected foo || exit 1
- $ssltest -bio_pair -tls1 -alpn_client foo,bar -alpn_server foo -alpn_expected foo || exit 1
- $ssltest -bio_pair -tls1 -alpn_client bar,foo -alpn_server foo -alpn_expected foo || exit 1
- $ssltest -bio_pair -tls1 -alpn_client bar,foo -alpn_server foo,bar -alpn_expected foo || exit 1
- $ssltest -bio_pair -tls1 -alpn_client bar,foo -alpn_server bar,foo -alpn_expected bar || exit 1
- $ssltest -bio_pair -tls1 -alpn_client foo,bar -alpn_server bar,foo -alpn_expected bar || exit 1
- $ssltest -bio_pair -tls1 -alpn_client baz -alpn_server bar,foo || exit 1
- if ../util/shlib_wrap.sh ../apps/openssl no-srp; then
- echo skipping SRP tests
- else
- echo test tls1 with SRP
- $ssltest -tls1 -cipher SRP -srpuser test -srppass abc123 || exit 1
- echo test tls1 with SRP via BIO pair
- $ssltest -bio_pair -tls1 -cipher SRP -srpuser test -srppass abc123 || exit 1
- echo test tls1 with SRP auth
- $ssltest -tls1 -cipher aSRP -srpuser test -srppass abc123 || exit 1
- echo test tls1 with SRP auth via BIO pair
- $ssltest -bio_pair -tls1 -cipher aSRP -srpuser test -srppass abc123 || exit 1
- fi
- #############################################################################
- # Multi-buffer tests
- if [ -z "$extra" -a `uname -m` = "x86_64" ]; then
- $ssltest -cipher AES128-SHA -bytes 8m || exit 1
- $ssltest -cipher AES128-SHA256 -bytes 8m || exit 1
- fi
- exit 0
|